package FixitCounter; 

######################## Inportant note. ###########################
# If running this script on a Unix machine, it is recommended that #
# a -T be placed after the path to perl on the first line. like so:#
# #!/usr/bin/perl -T                                               #
# This will put the script into "Taint" mode, which is a very good #
# practice for cgi-scripts. Windows users should ask their system  #
# Administrator for the file extension required or Taint mode perl.#
####################################################################
####################################################################
#                   HTMLfixIT Statistical counter.                 #
#                       http://htmlfixit.com                       #
#                       Copyright Frank Hauptle.                   #
#                         All rights reserved.                     # 
#                            Version 0.9                           #
#                        RC1, 23 May 2003                          #
#         Please report any bugs to franki@htmlfixit.com           #
####################################################################
####################################################################
#                      THE USUAL DISCLAIMER.                       # 
# This software is provided by the copyright holders and           #
# contributors `as is' and any express or implied warranties,      # 
# including, but not limited to, the implied warranties of         #
# merchantability and fitness for a particular purpose are         #
# disclaimed.                                                      #
# In no event shall the author or contributors be liable for any   #
# direct, indirect, incidental, special, exemplary,or consequential# 
# damages (including, but not limited to, procurement of substitute#
# goods or services; loss of use, data, or profits; or business    #
# interruption) however caused and on any theory of liability,     #
# whether in contract, strict liability, or tort (including        #
# negligence or otherwise)  arising in any way out of the use of   #
# this software, even if advised of the possibility of such damage.#
#                                                                  #
# This software is distributed under the same terms as perl itself.#  
####################################################################

sub run {
####################################################################
#                    Configuration Settings.                       #
####################################################################
       # All config for this script is in the seperate counter_config.pl
       # file, for unix hosts, no modifications are necessary here.
       # For windows hosts, the two variables below should be changed
       # to the directory path that the script will reside in on the server.
       # for example: $path_to_lib = 'c:/Inetpub/Scripts/downloads';
       # DO NOT add a trailing / to the end.

my $path_to_lib    = '.';  
my $path_to_config = '.';

###################################################################

require "$path_to_lib/htmlfixit-lib.pl";
require "$path_to_config/counter_config.pl";

use CGI qw(:standard);
use CGI::Cookie;
      # Some security stuff.
$CGI::DISABLE_UPLOADS = 1;
$CGI::POST_MAX        = 512 * 1024;

my $query = new CGI;
# If $demo is 1, then assume demo mode, 
# if $demo is 0, assume normal operation.
my $demo              = 0;

       # Get the configuration values.
my ($user_name, $pass_word, $sitename, $output_image_path, $days_before_archiving_stats, $archives_dir,
        $stats_file, $total_counter_file, $overall_count, $ip_ignore, $used_ips_dir, $script_name, $ip_age, $domain, $path, 
        $expiration, $cookie_id, $tmp_dir) = counter_config::config();

my $date = htmlfixit::get_date();
my $timestamp = time;

# Referer in perl is no good for this script as it will
# always be the page with the image preload javascript.
# my $referer    =  $ENV{'HTTP_REFERER'};
# So instead we get the referer via javascript and pass it to this script.

my ($referer, $screen_res);
if (defined $query->param('ref'))
   {
   $referer = $query->param('ref');  
   }
else{$referer = 'No referer or unundetectable';}

if (defined $query->param('res'))
   {
   $screen_res = $query->param('res');  
   }
else{$screen_res = 'Not detectable';}

# DO NOT CHANGE THIS SETTING, IT IS NOT EFFECTIVE IN THIS VERSION YET.
my $ignore_certain_ips = 'yes'; # Yes or no. (just yes at present)
       # If the above is yes, then the below file will store
       # IP address's that you want the counter to ignore.
       # Put your own IP in there. (one IP per line.)

       # We have to open the stats file and make sure the oldest entry
       # is not over the set time period and if it is, archive it and
       # start a new one.
my $first_stat = read__first_stat($stats_file);
my @first_line = split(/\|/, $first_stat);
my $voting = 0;       
       # Grab the first timestamp from the stats file.
my $first_hit_date = $first_line[2];
   $first_hit_date = 0 if $first_hit_date eq '';
       # Subtract the first hit date from the current date.
my $age_diff_seconds = ($timestamp - $first_hit_date );
       # Work it out in days and round it down to an integer.
my $age_diff_days = int(((($age_diff_seconds / 60) / 60) / 24));
       # How long till the next archiving?
my $days_till_archiving;
       if ($age_diff_days > $days_before_archiving_stats)
          {$days_till_archiving = 0;}
       else   
       {$days_till_archiving = $days_before_archiving_stats - $age_diff_days;}

my $new_date_filename = $date;
   $new_date_filename =~ tr/[\,\:\ ]/_/;

my $archive_timestamp = $new_date_filename;

unless ($first_hit_date == 0)
{
if ($age_diff_days > $days_before_archiving_stats) 
        {
             # Archive the stat file and start again.
        my $archive_name = $archives_dir . '/' .$new_date_filename . '.txt';
             # Rename the datafile and move it to its new location
        rename ("$stats_file","$archive_name") || die "Can't move file $stats_file $!";
             # Recreate the datafile, empty except for the date.:
        open (FILE, ">$stats_file");    
        flock(FILE,2) or die "cannot lock file: $stats_file $!";
        flock(FILE, 8);
        close (FILE);
        $age_diff_days = 0;
         
              # Archive the main counter file and likewise start again.
        my $counter_archive_name = $archives_dir . '/counter-' .$new_date_filename . '.txt';
        rename ("$total_counter_file","$counter_archive_name") || die "Can't move file $total_counter_file $!";
             # Recreate the counter file, with counts all set to 0.:
        open (FILE, ">$total_counter_file");    
        flock(FILE,2) or die "cannot lock file: $total_counter_file $!";
        print FILE '0|0|0';
        flock(FILE, 8);
        close (FILE);        
        
        }
}

# Get the login status.


my ($login_status, $login_message, $session) = htmlfixit::login_code($query, $cookie_id, 'username', 
                                                             'password', 'login',  
                                                             $user_name, $pass_word, 
                                                             'count', $tmp_dir,$domain, 
                                                             $path, $expiration);

if    ($login_status == 0){htmlfixit::not_specified_error(); goto _end;}
elsif ($login_status == 1){what_to_do_admin($query, $total_counter_file, $stats_file, $sitename, $date, $voting, $age_diff_days, $days_till_archiving, $script_name, $overall_count); goto _end;}
elsif ($login_status == 2){htmlfixit::display_login('Stats Counter', $script_name, 'login=yes', $login_message,$demo,$user_name,$pass_word); goto _end;}
elsif ($login_status == 3){htmlfixit::display_login('Stats Counter', $script_name, 'login=yes', $login_message,$demo,$user_name,$pass_word); goto _end;}
elsif ($login_status == 4){what_to_do_action($query, $date, $timestamp); goto _end;}
else {goto _end;}
# Create a label to send script to end.
_end:
} # End of sub run.

#############################
sub what_to_do_action
        {
        # This subs job is to determine what action task is to be performed and run the appropriate code.
        my ($query, $date, $timestamp) = @_;
        &increment_count($query, $date, $timestamp);
        }

#############################
sub what_to_do_admin
  {
        # This subs job is to determine what admin task is to be performed and run the appropriate code.
        my ($query, $total_counter_file, $stats_file, $sitename, $date, $voting, $age_diff_days, $days_till_archiving, $script_name, $overall_count) = @_;
        my ($start_date, $end_date); 
        $start_date = $query->param('start_date') || 'no start date';
        $end_date   = $query->param('end_date')  || 'no end date';
 
 # sitename=$sitename&amp;start_date=$start_date&amp;end_date=$end_date
 
 
        if ( $query->param('display'))
        {
           if ( $query->param('display') eq 'ref' )
           {
           display_referrers($script_name, $stats_file, $sitename, $date, $start_date, $end_date);
            }
        }
        else{
            &display_stats($total_counter_file, $stats_file, $sitename, $date, $voting, $age_diff_days, $days_till_archiving, $script_name, $overall_count);
            }
 }

#############################
sub increment_count
 {
 my ($query, $date, $timestamp) = @_;
 my $ip_address =  $ENV{'REMOTE_ADDR'};
     chomp $ip_address;
 my $http_host  =  $ENV{'HTTP_HOST'};
 my $browser    =  $ENV{'HTTP_USER_AGENT'};
 my $request    =  $ENV{'REQUEST_METHOD'};
 
 # Referer in perl is no good for this script as it will
 # always be the page with the image preload javascript.
 # my $referer    =  $ENV{'HTTP_REFERER'};
 # So instead we get the referer via javascript and pass it to this script.
 
 my ($referer, $screen_res);
 if (defined $query->param('ref'))
    {
    $referer = $query->param('ref');  
    }
 else{$referer = 'No referer or unundetectable';}
 
 if (defined $query->param('res'))
    {
    $screen_res = $query->param('res');  
    }
else{$screen_res = 'Not detectable';}

 
# Get all the config data again, its simplier then passing it all to this sub and we need most of it anyway.
# We'll just assign those we don't want to undef, since the config sub does no processing as such, it should
# be nearly as fast as passing the data to the sub anyway.
my (undef, undef, undef, $output_image_path, undef, undef, $stats_file, $total_counter_file, $overall_count, $ip_ignore, 
    $used_ips_dir, $script_name, $ip_age, undef, undef, undef, undef, $tmp_dir) = counter_config::config();
    
my $match   = 0;
my $ipmatch = 0;
       # We store each IP address in a filename that is inserted into 
       # a specific directory. that way we can test the files age to determine
       # how old a specific IP is.
my @IP_files = get_ip_files_list($used_ips_dir);
       foreach my $filename (@IP_files)
              {
              my $file_name = $used_ips_dir.'/'.$filename;
              if (-M $file_name > $ip_age)
                 {
                chomp $filename;
                unless (-f $file_name){shift @IP_files; next;}
                 # Make sure the files are the ones we want to delete.
                 $filename =~ /^(\d+\.\d+\.\d+\.\d+)(\.txt)$/;
                 $filename = $1 . $2;
                 unlink("$used_ips_dir/$filename") or die("can't delete: $used_ips_dir/$filename Reason: $!");
                 shift @IP_files;
                 # Here the directory and @IP_files should both only
                 # contain filenames that exist and are less then 
                 # the specified age.
                 }
              }

       # Open the count file and get the current counts cos we will
       # need it for most of the comming code.
       # The first field is unique hits, the second is all hits bar 
       # those from ignored IP's and the third is all hits bar nothing.
my ($unique, $total_without_ignored, $allhits, $first_hit_date, 
    $first_hit_timestamp, $overall_unique, $overall_total_without_ignored, 
    $overall_allhits) = get_count($total_counter_file, $overall_count);
    
my $ip;  
my $ignore_certain_ips = 'yes';    
    
if ($ignore_certain_ips eq 'yes')
{
# Open IP To look for a match
open (IP, "$ip_ignore")||  die "Error Can't open IP list file $ip_ignore $!";
flock(IP, 1) or die "cannot lock $ip_ignore reason $!";
my @IP_array = <IP>;
flock(IP, 8);
close (IP);
   foreach $ip (@IP_array)
   {   
    chomp $ip;
         if($ip eq $ip_address)
           {
           $match += 1;
           }
   } #end of foreach


if ($match > 0){
                # Here we know that a known IP has hit the page.
                # Do we do nothing except display the gif and increment the allhits count.
                &output_image($output_image_path);
                $allhits +=1;
                $overall_allhits += 1;
                &update_counter($total_counter_file, $overall_count, $unique, $total_without_ignored, $allhits,
                                $first_hit_date, $first_hit_timestamp, $overall_unique,
                                $overall_total_without_ignored,  $overall_allhits);
                                
                }

if ($match == 0)
   {
    # NO match to ignored IP. so now lets increment and collect data.
    # Increment the main counter file.
    $allhits                       += 1;
    $total_without_ignored         += 1;
    # increment the overall counter file.
    $overall_total_without_ignored += 1;
    $overall_allhits               += 1;
    
    # If the directory is totally empty, the foreach won't go anywhere, 
    # so we need allow and test for that.
        my $array_count = scalar(@IP_files);
        if ($array_count == 0)
        {       # There are no stored IP's at this point.
                $unique         +=1;
                $overall_unique +=1;
                my $total_collected_data = ($unique . '|' . $date . '|' . $timestamp . '|' . $ip_address . '|' . $screen_res . '|' . $browser . '|' . $referer . "\n");
                &write_stats($stats_file, $total_collected_data); 
                &write_ip_to_file($used_ips_dir, $ip_address);
        }

  if ($array_count >= 1)
  {
            foreach my $ipnum (@IP_files)
            {
            ($ipnum, undef) = split(/\.txt/, $ipnum);
            if ($ipnum eq $ip_address)
                {
                $ipmatch  = 1;
                }

             }
                    if ($ipmatch == 0)
                       {
                       $unique         +=1;
                       $overall_unique += 1;
                       my $total_collected_data = ($unique . '|' . $date . '|' . $timestamp . '|' . $ip_address . '|' . $screen_res . '|' . $browser . '|' . $referer . "\n");
                       &write_ip_to_file($used_ips_dir, $ip_address);
                       &write_stats($stats_file, $total_collected_data);       
                       }          
             
   } # End of: if ($array_count >= 1) 
   
    &update_counter($total_counter_file, $overall_count, $unique, $total_without_ignored, $allhits,
                    $first_hit_date, $first_hit_timestamp, $overall_unique,
                    $overall_total_without_ignored,  $overall_allhits);   
    &output_image($output_image_path);
   } # if ($match == 0)
 } # End of $ignore_certain_ips eq 'yes'
} # End of if $query->parem('count').


sub display_stats
{
my $total_counter_file = shift;
my $stats_file         = shift;
my $sitename           = shift;
my $date               = shift;
my $voting             = shift;
my $age_diff_days      = shift;
my $days_till_archiving= shift;
my $script_name        = shift;
my $overall_count      = shift;

my $css = htmlfixit::display_css();

my ($counts, $overall_counts) = read_counts($total_counter_file, $overall_count);

my @stats = read_stats($stats_file); 

$counts = 'no counts|no counts|no counts' if (! defined $counts);
$overall_counts = 'no hits yet|0|no hits yet|no hits yet|no hits yet' if (! defined $overall_counts);

my ($unique, $total_without_ignored, $total_hits) = split(/\|/, $counts);
my ($first_hit_date, $first_hit_timestamp, $all_unique, $all_total_without_ignored, $all_total_hits) = split(/\|/, $overall_counts);

my ($hitnumber, $hitdate, $timestamp, $hitip, $hitresolution, $hitbrowser, $hitreferer) = 'Not Detected';
my (@hitdate, @hitip, @hitresolution, @hitbrowser, @hitreferer); 


foreach my $hit (@stats)
{
        chomp $hit;
        if ($hit ne '') 
        {
        ($hitnumber, $hitdate, $timestamp, $hitip, $hitresolution, $hitbrowser, undef) = split(/\|/, $hit);
        push (@hitdate, $hitdate);
        push (@hitip, $hitip);
        push (@hitresolution, $hitresolution);
        push (@hitbrowser, $hitbrowser);
        }
        else
        {
        next;
        }
}

my $start_date = shift(@hitdate);
my $end_date   = pop(@hitdate);

my ($ie6, $ie5, $ie_other, $moz, $firebird, $ns4, $ns_other, $op7, $op6, $op_other, $safari, $konq, $galeon, $webtv, $others ) = 0.0;
my ($winXP, $win2000, $winNT, $winME, $win98, $win95, $win_other, $unix, $mac_OSX, $Mac_Classic, $OS_others) =0;
my ($res640x480, $res800x600, $res1024x768, $res1280x1024, $res1600x1200, $res_others) = 0;
my ($res560x420, $res1152x864, $res1152x870, $res1152x900, $res1280x960, $res1440x900, $res1400x1050, $res2048x768, $res2304x864) = 0;

     # Most of these could have been combined into single regex's, but 
     # I figure it will need regular updating so I kept them seperate.
     
# New browsers and Operating systems to add.
#Browsers:
#iCab
#SpaceBison (Proxomitron proxy)
#Chimera
#Camino

#Operating sys:
#SunOS
#IRIX
#OS/2
#FreeBSD
#SCO_SV
#OpenBSD
     
foreach my $browse (@hitbrowser)
{
$ie6         += 1 if (($browse =~ m|MSIE 6\.|) && ($browse !~ m|Opera|));
$ie5         += 1 if (($browse =~ m|MSIE 5\.|) && ($browse !~ m|Opera|));
$ie_other    += 1 if (($browse =~ m|MSIE|) && ($browse !~ m|MSIE 5\.|) 
                                           && ($browse !~ m|MSIE 6\.|) 
                                           && ($browse !~ m|Opera|));
$moz         += 1 if (($browse =~ m|Mozilla\/5\.|) && ($browse =~ m|Gecko|) 
                                                   && ($browse !~ m|Safari|) 
                                                   && ($browse !~ m|Galeon|) 
                                                   && ($browse !~ m|Firebird|) 
                                                   && ($browse !~ m|Konqueror|));
                                                   
$firebird    += 1 if (($browse =~ m|Firebird|));                                                  
$ns4         += 1 if (($browse =~ m|Mozilla\/4\.7|));
# Don't know enough about netscape 4 and lower to check for it yet.
$op7         += 1 if (($browse =~ m|Opera 7\.|));
$op6         += 1 if (($browse =~ m|Opera 6\.|));
$op_other    += 1 if (($browse =~ m|Opera|) && ($browse !~ m|Opera 7\.|) 
                                            &&($browse !~ m|Opera 6\.|));
$safari      += 1 if (($browse =~ m|Safari|));
$konq        += 1 if (($browse =~ m|Konqueror|));
$galeon      += 1 if (($browse =~ m|Galeon|));
$webtv       += 1 if (($browse =~ m|WebTV|));
$others = 0; # I don't yet have enough info to finish this yet.


$winXP       += 1 if (($browse =~ m|Windows NT 5\.1|));
$win2000     += 1 if (($browse =~ m|Windows NT 5\.0|) || ($browse =~ m|Windows 2000|));
$winNT       += 1 if (($browse =~ m|Windows NT|) && ($browse !~ m|Windows NT 5|));

$winME       += 1 if (($browse =~ m|Windows ME|));
$win98       += 1 if (($browse =~ m|Windows 98|) || ($browse =~ m|Win98|)) && ($browse !~ m|Win 9x|);

$win95       += 1 if (($browse =~ m|Win95|) || ($browse =~ m|Win 9x|) && ($browse !~ m|Windows 9.|) );
$win_other   += 1 if (($browse =~ m|Windows|) && ($browse !~ m|Windows NT|) 
                                              && ($browse !~ m|Windows ME|) 
                                              && ($browse !~ m|Windows 98|) 
                                              && ($browse !~ m|Win9\..|) 
                                              && ($browse !~ m|Win 9x|) 
                                              && ($browse !~ m|Windows 2000|));
                                              
$unix        += 1 if (($browse =~ m|Unix|) || ($browse =~ m|Linux|));
$mac_OSX     += 1 if (($browse =~ m|Mac OS X|));
$Mac_Classic += 1 if (($browse =~ m|Mac_PowerPC|) || ($browse =~ m|APPLE|));
$OS_others   += 1 if (($browse !~ m|Mac_PowerPC|) 
              && ($browse !~ m|APPLE|)   && ($browse !~ m|Mac OS X|) 
              && ($browse !~ m|Linux|)   && ($browse !~ m|Unix|)
              && ($browse !~ m|Windows|) && ($browse !~ m|Win9.|) && ($browse !~ m|Win 9.|));

# Don't know enough for other.
} #end of foreach.
$ie6      = 0 if (! $ie6);
$ie5      = 0 if (! $ie5);
$ie_other = 0 if (! $ie_other);
$moz      = 0 if (! $moz);
$ns4      = 0 if (! $ns4);
$ns_other = 0 if (! $ns_other);
$op7      = 0 if (! $op7);
$op6      = 0 if (! $op6);
$op_other = 0 if (! $op_other);
$safari   = 0 if (! $safari);
$konq     = 0 if (! $konq);
$galeon   = 0 if (! $galeon);
$webtv    = 0 if (! $webtv);
$others   = 0 if (! $others);
$winXP    = 0 if (! $winXP);
$win2000  = 0 if (! $win2000);
$winNT    = 0 if (! $winNT);
$winME    = 0 if (! $winME);
$win98    = 0 if (! $win98);
$win95    = 0 if (! $win95);
$win_other   = 0 if (! $win_other);
$unix        = 0 if (! $unix); 
$mac_OSX     = 0 if (! $mac_OSX);
$Mac_Classic = 0 if (! $Mac_Classic);
$OS_others   = 0 if (! $OS_others);


# $720x480, $720x576, $768x1024, $832x624, $960x720, $1152x768, $1280x720, $1280x768, $1280x800, $1280x854, $1280x993, $1536x960, $1600x1024, $1600x1280, $1920x1200, $2560x1024

# New Screen Res's to add.
#720x480
#720x576
#832x624
#960x720
#1152x768
#1280x720
#1280x768
#1280x800
#1280x854
#1280x993
#1536x960
#1600x1024
#1600x1280
#1920x1200
#2560x1024

foreach my $Resolution (@hitresolution)
{
$res640x480   += 1 if (($Resolution =~ m|640x480|));
$res800x600   += 1 if (($Resolution =~ m|800x600|));
$res1024x768  += 1 if (($Resolution =~ m|1024x768|) || ($Resolution =~ m|768x1024|));
$res1280x1024 += 1 if (($Resolution =~ m|1280x1024|));
$res1600x1200 += 1 if (($Resolution =~ m|1600x1200|));

$res560x420    += 1 if (($Resolution =~ m|560x420|));
$res1152x864   += 1 if (($Resolution =~ m|1152x864|));
$res1152x870   += 1 if (($Resolution =~ m|1152x870|));
$res1152x900   += 1 if (($Resolution =~ m|1152x900|));
$res1280x960   += 1 if (($Resolution =~ m|1280x960|));
$res1440x900   += 1 if (($Resolution =~ m|1440x900|));
$res1400x1050  += 1 if (($Resolution =~ m|1400x1050|));
$res2048x768   += 1 if (($Resolution =~ m|2048x768|));
$res2304x864   += 1 if (($Resolution =~ m|2304x864|));

$res_others   += 1 if (($Resolution !~ m|640x480|) 
                    && ($Resolution !~ m|800x600|)
                    && ($Resolution !~ m|1024x768|) 
                    && ($Resolution !~ m|768x1024|)
                    && ($Resolution !~ m|1280x1024|) 
                    && ($Resolution !~ m|1600x1200|)
                    
                    && ($Resolution !~ m|560x420|)
                    && ($Resolution !~ m|1152x864|)
                    && ($Resolution !~ m|1152x870|)
                    && ($Resolution !~ m|1152x900|)
                    && ($Resolution !~ m|1280x960|)
                    && ($Resolution !~ m|1440x900|)
                    && ($Resolution !~ m|1400x1050|)
                    && ($Resolution !~ m|2048x768|)
                    && ($Resolution !~ m|2304x864|));
}
$res560x420    = 0 if (! $res560x420);
$res640x480    = 0 if (! $res640x480);
$res800x600    = 0 if (! $res800x600);
$res1024x768   = 0 if (! $res1024x768);
$res1152x864   = 0 if (! $res1152x864);
$res1152x870   = 0 if (! $res1152x870);
$res1152x900   = 0 if (! $res1152x900);
$res1280x960   = 0 if (! $res1280x960);
$res1280x1024  = 0 if (! $res1280x1024);
$res1400x1050  = 0 if (! $res1400x1050);
$res1440x900   = 0 if (! $res1440x900);
$res1600x1200  = 0 if (! $res1600x1200);
$res2048x768   = 0 if (! $res2048x768);
$res2304x864   = 0 if (! $res2304x864);
$res_others    = 0 if (! $res_others);

# Divide the numbe of unique hits by the number of days since the first hit
#, but first make sure the age is not 0 as its bad to divide 0.
my $unique_average;
if ($age_diff_days > 0)
{
$unique_average = ($unique / $age_diff_days);
}
else 
{$unique_average = $unique;}

$unique_average = sprintf("%.2f", $unique_average); 
$voting = 1;
my $vote_output;

if ($voting == 1)
{$vote_output = htmlfixit::voting('\'Stats Counter\'', 'http://htmlfixit.com/vote.php'); }
else{$vote_output = '&nbsp;';}

# This is the main statistical dislay page.                                                 
print "Content-type: text/html\n\n";

# Probably not necessary, but just in case, lets give everything a value 
# if it doens't already have one to stop Perl from issuing warnings.
# about using variables that have not been defined.

$first_hit_date                 = 'no hits yet' unless defined $first_hit_date;
$all_unique                     = 1 unless defined $all_unique; 
$all_total_without_ignored      = 1 unless defined $all_total_without_ignored; 
$all_total_hits                 = 1 unless defined $all_total_hits;
$start_date                     = 'no hits yet' unless defined $start_date;
$unique                         = 1 unless defined $unique;
$total_without_ignored          = 1 unless defined $total_without_ignored;
$total_hits                     = 1 unless defined $total_hits;
$unique_average                 = 1 unless defined $unique_average;

my $admin_header = output_admin_header($script_name, $sitename, $date, $start_date, $end_date);

print <<ENDOFSTATS;
$admin_header
$vote_output
<br />

<div align='center' class='content'>
<br />

<div class='cont'>
<table border='0' align='center'>
   
    <tr>
      <td colspan='2' align='center'><strong>Overall Hit count summary since:<br /> $first_hit_date.</strong><br /><hr noshade='noshade' /></td>
   </tr>  
    <tr>   
      <td align= 'left'>Total unique hits:</td><td align= 'left'>$all_unique</td>
   </tr>   
    <tr>   
       <td align= 'left'>With ignored IP's:</td><td align= 'left'>$all_total_without_ignored</td>
   </tr>
    <tr>   
       <td align= 'left'>All hits:</td><td align= 'left'>$all_total_hits</td>
   </tr> 
   <tr>
      <td colspan='2'><hr noshade='noshade' /></td>
   </tr>
    <tr>
      <td colspan='2' align='center'><strong>Total Hit count summary since last rollover on:<br /> $start_date.</strong><br /><hr noshade='noshade' /></td>
   </tr>     
    <tr>
      <td align= 'left'>Unique hits for this period:</td><td align= 'left'>$unique</td>
   </tr>
   <tr>
      <td align= 'left'>Hits without counting ignored address's :</td><td align= 'left'>$total_without_ignored</td>
   </tr>
   <tr>
      <td align= 'left'>All hits, including ignored address's and non unique hits:</td><td align= 'left'>$total_hits</td>
   </tr>
   <tr>
      <td align= 'left'>Average unique hits per day:</td><td align= 'left'>$unique_average</td>
   </tr>   
   <tr>
      <td colspan='2'><hr noshade='noshade' /></td>
   </tr>   
</table>
</div>
<br />
</div>
<br />
<div align='center' class='content'>
<br />
<div class='cont'>
<table border='0' width='60%' align='center'>
   <tr>
      <td align=' left' colspan='2'><strong><br /><a name='browse'>Browser statistics for the last $unique hits..</a></strong><br /><hr noshade='noshade' /></td>
   </tr>
   <tr>
      <td align= 'left'>Internet Explorer 6:</td><td align= 'left'>$ie6</td>
   </tr>
   <tr>
      <td align= 'left'>Internet Explorer 5:</td><td align= 'left'>$ie5</td>
   </tr>
   <tr>
      <td align= 'left'>Internet Explorer other:</td><td align= 'left'>$ie_other</td>
   </tr>
  <tr>
      <td align= 'left'><br /></td><td align= 'left'></td>
  </tr>
   <tr>
      <td align= 'left'>Netscape 6+ / Mozilla 1+ :</td><td align= 'left'>$moz</td>
   </tr>
   <tr>
      <td align= 'left'>Mozilla Firebird:</td><td align= 'left'>$firebird</td>
   </tr>   
   <tr>
      <td align= 'left'>Netscape 4.x:</td><td align= 'left'>$ns4</td>
   </tr>
   <tr>
      <td align= 'left'>Netscape other:</td><td align= 'left'>$ns_other</td>
   </tr>
  <tr>
      <td align= 'left'><br /></td><td align= 'left'></td>
  </tr>
   <tr>
      <td align= 'left'>Opera 7.x:</td><td align= 'left'>$op7</td>
   </tr>
   <tr>
      <td align= 'left'>Opera 6.x:</td><td align= 'left'>$op6</td>
   </tr>
   <tr>
      <td align= 'left'>Opera other:</td><td align= 'left'>$op_other</td>
   </tr>
  <tr>
      <td align= 'left'><br /></td><td align= 'left'></td>
  </tr>
   <tr>
      <td colspan='2'><b>Misc browsers.</b></td>
   </tr>   
  <tr>
      <td align= 'left'>Safari:</td><td align= 'left'>$safari</td>
  </tr> 
  <tr>
      <td align= 'left'>Konqueror:</td><td align= 'left'>$konq</td>
  </tr>
  <tr>
      <td align= 'left'>Galeon:</td><td align= 'left'>$galeon</td>
  </tr>
  <tr>
      <td align= 'left'>WebTV:</td><td align= 'left'>$webtv</td>
  </tr>  
  <tr>
      <td align= 'left'>Others:</td><td align= 'left'>$others</td>
  </tr>  
   <tr>
      <td colspan='2'><hr noshade='noshade' /></td>
   </tr>   
</table>
</div>
<br />
</div>
<br />
<div align='center' class='content'>
<br />
<div class='cont'>
<table border='0' width='60%' align='center'>
   <tr>
      <td align=' left' colspan='2'><strong><br /><a name='OS'>Operating system stats for the last $unique hits.</a></strong><br /><hr noshade='noshade' /></td>
   </tr>
   <tr>
      <td align= 'left'>Windows XP:</td><td align= 'left'>$winXP</td>
   </tr>
   <tr>
      <td align= 'left'>Windows 2000:</td><td align= 'left'>$win2000</td>
   </tr>
   <tr>
      <td align= 'left'>Windows NT4:</td><td align= 'left'>$winNT</td>
   </tr>   
   <tr>
      <td align= 'left'>Windows ME:</td><td align= 'left'>$winME</td>
   </tr>
    <tr>
      <td align= 'left'>Windows 98:</td><td align= 'left'>$win98</td>
   </tr>
    <tr>
      <td align= 'left'>Windows 95:</td><td align= 'left'>$win95</td>
   </tr>   
   <tr>
      <td align= 'left'>Windows other:</td><td align= 'left'>$win_other</td>
   </tr>    
  <tr>
      <td align= 'left'><br /></td><td align= 'left'></td>
   </tr>   
   <tr>
      <td align= 'left'>Linux/Unix:</td><td align= 'left'>$unix</td>
   </tr>
   <tr>
      <td align= 'left'><br /></td><td align= 'left'></td>
   </tr>   
   <tr>
      <td align= 'left'>Macintosh OSX:</td><td align= 'left'>$mac_OSX</td>
   </tr>  
   <tr>
      <td align= 'left'>Macintosh Classic:</td><td align= 'left'>$Mac_Classic</td>
   </tr>   
   <tr>
      <td align= 'left'><br /></td><td align= 'left'></td>
   </tr>
   <tr>
      <td align= 'left'>Misc:</td><td align= 'left'>$OS_others</td>
   </tr>  
   <tr>
      <td colspan='2'><hr noshade='noshade' /></td>
   </tr>   
</table>
</div>
<br />
</div>
<br />
<div align='center' class='content'> 
<br />
<div class='cont'>
<table border='0' width='60%' align='center'>
   <tr>
      <td align=' left' colspan='2'><strong><br /><a name='res'>Screen resolution stats for the last $unique hits.</a></strong><br /><hr noshade='noshade' /></td>
   </tr>
   <tr>
      <td align= 'left'>560 x 420:</td><td align= 'left'>$res560x420</td>
   </tr>
   <tr>
      <td align= 'left'>640 x 480:</td><td align= 'left'>$res640x480</td>
   </tr>
   <tr>
      <td align= 'left'>800 x 600:</td><td align= 'left'>$res800x600</td>
   </tr>
   <tr>
      <td align= 'left'>1024 x 768:</td><td align= 'left'>$res1024x768</td>
   </tr>  
   <tr>
      <td align= 'left'>1152 x 864:</td><td align= 'left'>$res1152x864</td>
   </tr>  
   <tr>
      <td align= 'left'>1152 x 870:</td><td align= 'left'>$res1152x870</td>
   </tr>  
   <tr>
      <td align= 'left'>1152 x 900:</td><td align= 'left'>$res1152x900</td>
   </tr> 
   <tr>
      <td align= 'left'>1280 x 960:</td><td align= 'left'>$res1280x960</td>
   </tr>   
   <tr>
      <td align= 'left'>1280 x 1024:</td><td align= 'left'>$res1280x1024</td>
   </tr> 
   <tr>
      <td align= 'left'>1440 x 900:</td><td align= 'left'>$res1440x900</td>
   </tr>   
   <tr>
      <td align= 'left'>1400 x 1050:</td><td align= 'left'>$res1400x1050</td>
   </tr>  
   <tr>
      <td align= 'left'>1600 x 1200:</td><td align= 'left'>$res1600x1200</td>
   </tr>
   <tr>
      <td align= 'left'>2048 x 768:</td><td align= 'left'>$res2048x768</td>
   </tr>   
   <tr>
      <td align= 'left'>2304 x 864:</td><td align= 'left'>$res2304x864</td>
   </tr>    
   <tr>
      <td align= 'left'>Other:</td><td align= 'left'>$res_others</td>
   </tr> 
   <tr>
      <td colspan='2'><hr noshade='noshade' /></td>
   </tr>   
</table>
</div>
<br />
</div>
<br />
</body>
</html>
ENDOFSTATS
}
################################
# Prints the header html for all admin pages.
#
# Usage: output_admin_header('script_name', 'sitename' 'current date', 'stat start date', 'stat end date');
sub output_admin_header
{
my $script_name = shift;
my $sitename    = shift;
my $date        = shift;
my $start_date  = shift;
my $end_date    = shift;
my $css = htmlfixit::display_css();
my $version     = '1.00';

# Just as a last minute check,  make sure all the vars have a value set 
# to stop perl complaining if it doesn't.
$script_name = 'stats.pl'           unless defined $script_name;
$sitename    = 'mydomain.com'       unless defined $sitename;
$date        = 'date not available' unless defined $date;
$start_date  = 'date not available' unless defined $start_date;
$end_date    = 'date not available' unless defined $end_date;

my $header = <<ENDOFHEADER;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html><head>
<title>HTMLfixIT.com Statistical page counter for $sitename.</title>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
$css
</head>
<body>
<br />

<div align='center' class='content'> 
<br />
<div class='cont'>
<h1 align='center'><a href='http://HTMLfixIT.com' class='menu' target='_blank'>HTMLfixIT.com</a></h1>

<h3>Statistical counter for "$sitename"</h3>
<p align='center'><b>Todays date:&nbsp;&nbsp;</b> $date</p>
<table  width='98%' cellpadding='0' cellspacing='0'>
<tr>
  <td>&nbsp;</td>
  <td>&nbsp;</td>
</tr>
<tr>
  <td><b>The first stat was collected on:</b></td>
  <td>$start_date</td>
</tr>
<tr>
  <td>&nbsp;</td>
  <td>&nbsp;</td>
</tr>
<tr>
  <td><b>The last stat was collected on:</b></td>
  <td>$end_date</td>
</tr>
<tr>
  <td>&nbsp;</td>
  <td>&nbsp;</td>
</tr>
</table>
</div>
<br />
</div>
<br />
<div align='center' class='content'>
<br />
<div class='cont'>
<h2 align='center' style='margin-top:5px; margin-bottom:5px;'>Statistics shortcut menu.</h2>
<p>Move your mouse over the buttons to get a better description of what each does.</p>
<form action='http://htmlfixit.com/advanced.php' method='post' style='margin-top:5px; margin-bottom:5px;'>
<input type='button' value='Refresh count' title='Refresh the hit count.' class='buttons' onclick='location.href="$script_name?login=yes"' />&nbsp;
<input type='button' value='Browser stats' title='Go to the Browser statistics.' class='buttons' onclick='location.href="$script_name?login=yes#browse"' />
<input type='button' value='Operating Systems' title='Go to the Operating System statistics.' class='buttons' onclick='location.href="$script_name?login=yes#OS"' />&nbsp;
<input type='button' value='Screen Resolutions' title='Go to the Screen Resoluton statistics.' class='buttons' onclick='location.href="$script_name?login=yes#res"' />
</form>
<br />
<hr width='95%' noshade='noshade' />
<h2 align='center' style='margin-top:0px; margin-bottom:5px;'>Advanced menu.</h2>
<table width='400px' cellpadding='0' cellspacing='0'>
<tr>
  <td>
<form style='margin-top:1px; margin-bottom:0px; margin-right:4px; margin-left:0px;' action='$script_name' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='ref' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='Show the list of refering web sites.'  value='Show referrers' class='buttons' />
</form>
  </td>
  <td>
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:4px;' action='http://htmlfixit.com/advanced.php' method='post'>
<input type='button' class='adbuttons' title='Show the breakdown of hits to all the pages in your site' onclick='alert("Only available in the advanced version.&nbsp;&nbsp;");return false;' value='Pages hit summary' />
</form>
  </td>
</tr>
<tr>
  <td>
<form style='margin-top:1px; margin-bottom:0px; margin-right:4px; margin-left:0px;' action='http://htmlfixit.com/advanced.php' method='post'>
<input type='button' class='adbuttons' title='A breakdown of terms used in search engines that lead to your site.' onclick='alert("Only available in the advanced version.&nbsp;&nbsp;");return false;' value='Search engine summary' />
</form>
  </td>
  <td>
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:4px;' action='http://htmlfixit.com/advanced.php' method='post'>
<input type='button' class='adbuttons' title='A day by day breakdown of hits to your site.' onclick='alert("Only available in the advanced version.&nbsp;&nbsp;");return false;' value='Day by day counts' />
</form>
  </td>
</tr>
<tr>
  <td>
<form style='margin-top:1px; margin-bottom:0px; margin-right:4px; margin-left:0px;' action='http://htmlfixit.com/advanced.php' method='post'>
<input type='button' class='adbuttons' title='Set the count back to zero now.' onclick='alert("Only available in the advanced version.&nbsp;&nbsp;");return false;' value='Roll over counts now' />
</form>
  </td>
  <td>
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:4px;' action='http://htmlfixit.com/advanced.php' method='post'>
<input type='button' class='adbuttons' title='Shows what countries your hits are comming from.' onclick='alert("Only available in the advanced version.&nbsp;&nbsp;");return false;' value='Countries of hits summary' />
</form>
  </td>
</tr>
<tr>
  <td colspan='2' align='center'>
  <a href='http://htmlfixit.com/advanced.php' title='This link will take you to a page detailing what the advanced version can do, and how to get it.' class='menu' target='_blank'>Advanced statistical counter information.</a>
  </td>
</tr>
</table>
<br />
</div><br />
</div>
<br />
<div class='content' align='center'><br /><div class='cont'>
<iframe  width='500px' height='45px' frameborder='0' src='http://htmlfixit.com/inserts/insert-stats.php?ver=$version'>
</iframe>

</div><br /></div>
ENDOFHEADER

return $header;
}

################################
#
# usage: display_referrers($script_name, $stats_file, $sitename, $date, $start_date, $end_date);

sub display_referrers
{
my ($script_name, $stats_file, $sitename, $date, $start_date, $end_date) = @_;

# make sure the vars all have values before we try and use them.
$sitename     = 'mydomain.com'       unless defined $sitename;
$date         = 'date not available' unless defined $date;
$start_date   = 'date not available' unless defined $start_date;
$end_date     = 'date not available' unless defined $end_date;

my $admin_header = output_admin_header($script_name, $sitename, $date, $start_date, $end_date);
my @stats = read_stats($stats_file);

my $hitreferer = 'Not Detected';
my @hitreferer;
foreach my $hit (@stats)
{
        chomp $hit;
        if ($hit ne '') 
        {
        (undef, undef, undef, undef, undef, undef, $hitreferer) = split(/\|/, $hit);
        push (@hitreferer, $hitreferer);
        }
        else
        {
        next;
        }
}
my $ref_number = 1;
my $no_refs = 0;
my $referer_table;
foreach my $refering (@hitreferer)
{
chomp $refering;
$refering =~ s/</&lt;/;
$refering =~ s/>/&gt;/;
$refering =~ s/\n//;
        if (($refering eq '') || ($refering eq 'referrer blocked by AdSubtract') || ($refering eq 'No referer or unundetectable') || ($refering eq 'Hidden-Referrer') || ($refering eq 'blockedReferrer'))
        {
        $no_refs += 1;
        delete $hitreferer{"$refering"};
        next;
        }
$referer_table .= '<tr><td align= \'left\'><span class=\'small\'>'.$ref_number.'.&nbsp;<a href=\'' . $refering . '\' target=\'_blank\'>' . $refering . '</a></span></td></tr>' . "\n";
$ref_number += 1;
}

print "Content-type: text/html\n\n";

print <<ENDOFREFFERER;
$admin_header
<br />
<div align='center' class='content'>
<br />
<div class='cont'>
   <p align='center'><strong><br /><a name='refs'>Summary of pages that refered visitors to: "$sitename"</a></strong><br /><b>$no_refs</b> hits had no referer information.<br />
   (Usually this means the address to your site was entered manually or<br /> the link was followed from a non browser program like an email client.)<br /><br /></p>
</div><br />
<table border='0' width='40%' align='center'>
   $referer_table
    <tr><td align= 'left'><br /></td></tr>
      
</table>
</div>
<br /><br />
<p align='center'>Copyright &copy; 2003 Frank Hauptle <a href='http://htmlfixit.com' target='_blank'>HTMLfixIT.com</a><br /> All rights reserved.</p>
<br />
</body>
</html>
ENDOFREFFERER

}

################################
sub output_image
{
my $output_image_path = shift;
       local $/ = undef;
       open (IMAGE, "$output_image_path")||  die "Error Can't open: $output_image_path because: $!";
       flock(IMAGE, 1) or die "cannot lock image file: $!";
       # BINMODE IMAGE;
       my $image = <IMAGE>;
       print "Content-type: image/gif\n\n";
       print $image;
       close (IMAGE);
}
################################
sub write_stats
{
my $stats_file = shift;
my $total_collected_data = shift;

     open (STATS, ">>$stats_file")||  die "Can't open $stats_file $!";
     flock(STATS, 2) or die "cannot lock $stats_file: $!";
     print STATS "$total_collected_data";
     flock(STATS, 8);
     close (STATS);
} 
################################
# usage: my $first_stat = read__first_stat($stats_file); 
# This is a seperate sub from the one below because its 
# not necessary to use a loop to get just the first line 
# of the file, which is all we need to check the first hits 
# times stamp.
sub read__first_stat
{
my $stats_file = shift;
     open (STATS, "$stats_file")||  die "Can't open $stats_file $!";
     flock(STATS, 1) or die "cannot lock $stats_file: $!";
     my $first_stat = <STATS>;
     flock(STATS, 8);
     close (STATS);

return $first_stat;     
}

################################
# usage: my (@stats) = read_stats($stats_file); 
sub read_stats
{
my $stats_file = shift;
     open (STATS, "$stats_file")||  die "Can't open $stats_file $!";
     flock(STATS, 1) or die "cannot lock $stats_file: $!";
     my @stats = <STATS>;
     flock(STATS, 8);
     close (STATS);
return (@stats);     
}
################################
# usage: my ($counts, $overall_counts) = read_counts($total_counter_file, $overall_count);
sub read_counts
{
my $total_counter_file = shift;
my $overall_count      = shift; 

     open (COUNT, "$total_counter_file")||  die "Can't open $total_counter_file $!";
     flock(COUNT, 1) or die "cannot lock $total_counter_file: $!";
     my $counts = <COUNT>;
     flock(COUNT, 8);
     close(COUNT); 
     
     open (ALLCOUNT, "$overall_count")||  die "$overall_count $!";
     flock(ALLCOUNT, 1) or die "cannot lock $overall_count: $!";
     my $all_counts = <ALLCOUNT>;
     flock(ALLCOUNT, 8);
     close(ALLCOUNT);      
     
return ($counts, $all_counts);
}



################################
# usage: &update_counter($total_counter_file, $overall_count, $unique, $total_without_ignored, $allhits,
#                        $first_hit_date, $first_hit_timestamp, $overall_unique,
#                        $overall_total_without_ignored,  $overall_allhits);
sub update_counter
{
#     my ($total_counter_file, $overall_count, $unique, $total_without_ignored, $allhits,
#         $first_hit_date, $first_hit_timestamp, $overall_unique,
#         $overall_total_without_ignored,  $overall_allhits) = @_;
         
my $total_counter_file            = shift;
my $overall_count                 = shift;
# make sure we don't try to use undef values in the file writes.
my $unique                        = shift;
my $total_without_ignored         = shift;
my $allhits                       = shift;
my $first_hit_date                = shift;
my $first_hit_timestamp           = shift;
my $overall_unique                = shift;
my $overall_total_without_ignored = shift;
my $overall_allhits               = shift;

# Make sure all of the variables actually have a value.
$unique                        = 1 unless defined $unique;
$total_without_ignored         = 1 unless defined $total_without_ignored;
$allhits                       = 1 unless defined $allhits;
$first_hit_date                = 1 unless defined $first_hit_date;
$first_hit_timestamp           = 1 unless defined $first_hit_timestamp;
$overall_unique                = 1 unless defined $overall_unique;
$overall_total_without_ignored = 1 unless defined $overall_total_without_ignored;
$overall_allhits               = 1 unless defined $overall_allhits;

# Update the normal count file.
my $string = $unique . '|' . $total_without_ignored . '|' . $allhits;
     open (COUNT, ">$total_counter_file")||  die "Can't open $total_counter_file $!";
     flock(COUNT, 2) or die "cannot lock $total_counter_file: $!";
     print COUNT $string;
     flock(COUNT, 8);
     close(COUNT);
     
# Update the overall count file.     
my $overall_string = $first_hit_date.'|'.$first_hit_timestamp.'|'.$overall_unique.'|'.$overall_total_without_ignored.'|'.$overall_allhits;
     open (COUNT, ">$overall_count")||  die "Can't open $overall_count $!";
     flock(COUNT, 2) or die "cannot lock $overall_count: $!";
     print COUNT $overall_string;
     flock(COUNT, 8);
     close(COUNT);    
}
################################
# usage: my ($unique, $total_without_ignored, $allhits, $first_hit_date, $first_hit_timestamp, $overall_unique, 
#            $overall_total_without_ignored, $overall_allhits ) = get_count($total_counter_file, $overall_count);

sub get_count
{
my ($total_counter_file, $overall_count) = @_;
my ($count, $allcount);  
  # Get normal Count.
  open (COUNT, "$total_counter_file")||  die "Error, Can't open $total_counter_file  file $!";
  flock(COUNT, 1) or die "cannot lock $total_counter_file: $!";
  
  $count = <COUNT>;
  chomp $count;
  my ($unique, $total_without_ignored, $allhits) = split(/\|/, $count);
  flock(COUNT, 8);
  close (COUNT); 
  
  # Get overall Count.
  open (ALLCOUNT, "$overall_count")||  die "Error, Can't open $overall_count  file $!";
  flock(ALLCOUNT, 1) or die "cannot lock $overall_count: $!";
  
  $allcount = <ALLCOUNT>;
  chomp $allcount;
  my ($first_hit_date, $first_hit_timestamp, $overall_unique, $overall_total_without_ignored, $overall_allhits) = split(/\|/, $allcount);
  flock(ALLCOUNT, 8);
  close (ALLCOUNT);   
  
return ($unique, $total_without_ignored, $allhits, $first_hit_date, $first_hit_timestamp, $overall_unique, $overall_total_without_ignored, $overall_allhits);

}

#################################
# usage my @IP_files = get_ip_files_list($used_ips_dir);

sub get_ip_files_list
{
my $used_ips_dir = shift;
opendir (IPFILES, "$used_ips_dir") || die "can't open $used_ips_dir $!";
my @IP_files = grep(/\.[0-9, a-z, A-Z]/,readdir(IPFILES));
closedir (IPFILES);
return @IP_files;
}
#################################
# usage: &write_ip_to_file($used_ips_dir, $ip_address);

sub write_ip_to_file
{
my ($used_ips_dir, $ip_address) = @_;
my $new_filename = $ip_address . '.txt';
   # Make sure the file name is just an IP address.
   $new_filename =~ /^(\d+\.\d+\.\d+\.\d+)\.(\w+)$/;
   $new_filename = $1 .'.' .$2;

open (FILE, ">$used_ips_dir/$new_filename") or die("Can't open $used_ips_dir/$new_filename : Reason: $!");   
close (FILE);
}
#################################
1;